//
//  PagePresenter.swift
//  NasaProj
//
//  Created by NATCHANON TREERATTANANUKUL on 25/6/2566 BE.
//  Copyright (c) 2566 BE ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol PagePresentationLogic
{
    func presentApodModels (response: Page.ApodModels.Response)
    func presentSortData (response: Page.SortData.Response)
    func presentFavoriteItem (response: Page.FavoriteModels.Response)
    func fetchIsFail()
}

class PagePresenter: PagePresentationLogic
{
    weak var viewController: PageDisplayLogic?
    
    // MARK: Present ApodModels
    
    func presentApodModels (response: Page.ApodModels.Response){
        var apodViewModels: [Page.ApodModels.ViewModel.FetchModels] = []
        apodViewModels = response.data
        viewController?.displayAPODModels(viewModel:apodViewModels)
    }
    
    // MARK: Present SortData
    
    func presentSortData (response: Page.SortData.Response){
        let viewModel = Page.SortData.ViewModel()
        viewController?.displaySortData(viewModel: viewModel)
    }
    
    // MARK: Present Favorite Item
    
    func presentFavoriteItem (response: Page.FavoriteModels.Response) {
        let apodModels = Page.FavoriteModels.ViewModel()
        viewController?.displayFavoriteItem(viewModel: apodModels)
    }
    
    // MARK: Present Alert fetchFail
    
    func fetchIsFail () {
        let alert = UIAlertController(
            title: "Error",
            message: "Failed to fetch data. Do you want to retry?",
            preferredStyle: .alert
        )
        
        viewController?.showRetryAlert(alerts: alert)
    }
}
